/*
 * $Id: p_header,v 1.4 2000/11/27 01:57:01 keiko Exp $
 */

#include <stdio.h>
#include "ruby.h"
#include "libtinyf2c.h"
#include "narray.h"

#define DFLT_SIZE 32

extern char    *dcl_obj2ccharary(VALUE, int, int);
extern integer *dcl_obj2cintegerary(VALUE);
extern real    *dcl_obj2crealary(VALUE);
extern complex *dcl_obj2ccomplexary(VALUE);
extern logical *dcl_obj2clogicalary(VALUE);

extern VALUE dcl_ccharary2obj(char *, int, int);
extern VALUE dcl_cintegerary2obj(integer *, int, int, int *);
extern VALUE dcl_crealary2obj(real *, int, int, int *);
extern VALUE dcl_ccomplexary2obj(complex *, int, char *);
extern VALUE dcl_clogicalary2obj(logical *, int, int, int *);

extern void dcl_freeccharary(char *);
extern void dcl_freecintegerary(integer *);
extern void dcl_freecrealary(real *);
extern void dcl_freeccomplexary(complex *);
extern void dcl_freeclogicalary(logical *);

/* for functions which return doublereal */
/* fnclib */
extern doublereal rd2r_(real *);
extern doublereal rr2d_(real *);
extern doublereal rexp_(real *, integer *, integer *);
extern doublereal rfpi_(void);
extern doublereal rmod_(real *, real *);
/* gnmlib */
extern doublereal rgnlt_(real *);
extern doublereal rgnle_(real *);
extern doublereal rgngt_(real *);
extern doublereal rgnge_(real *);
/* rfalib */
extern doublereal rmax_(real *, integer *, integer *);
extern doublereal rmin_(real *, integer *, integer *);
extern doublereal rsum_(real *, integer *, integer *);
extern doublereal rave_(real *, integer *, integer *);
extern doublereal rvar_(real *, integer *, integer *);
extern doublereal rstd_(real *, integer *, integer *);
extern doublereal rrms_(real *, integer *, integer *);
extern doublereal ramp_(real *, integer *, integer *);
/* rfblib */
extern doublereal rprd_(real *, real *, integer *, integer *, integer *);
extern doublereal rcov_(real *, real *, integer *, integer *, integer *);
extern doublereal rcor_(real *, real *, integer *, integer *, integer *);


VALUE mDCL;

static VALUE
dcl_cns(obj, ins)
    VALUE obj, ins;
{
    integer i_ins;
    char *o_rtn_val;
    VALUE rtn_val;

    if ((TYPE(ins) != T_BIGNUM) || (TYPE(ins) != T_FIXNUM)) {
      ins = rb_funcall(ins, rb_intern("to_i"), 0);
    }

    i_ins = NUM2INT(ins);

    o_rtn_val= ALLOCA_N(char, (2));
    memset(o_rtn_val, '\0', 2);

    cns_(o_rtn_val, (ftnlen)1, &i_ins);

    rtn_val = rb_str_new2(o_rtn_val);


    return rtn_val;

}

static VALUE
dcl_cdblk(obj, chr)
    VALUE obj, chr;
{
    char *io_chr;

    if (TYPE(chr) != T_STRING) {
      chr = rb_funcall(chr, rb_intern("to_str"), 0);
    }

    io_chr = ALLOCA_N(char, strlen(STR2CSTR(chr))+1);
    strcpy(io_chr, STR2CSTR(chr));


    cdblk_(io_chr, (ftnlen)strlen(io_chr));

    chr = rb_str_new2(io_chr);


    return chr;

}
void
init_misc1_misclib(mDCL)
VALUE mDCL;
{
    rb_define_module_function(mDCL, "cns", dcl_cns, 1);
    rb_define_module_function(mDCL, "cdblk", dcl_cdblk, 1);
}
